SLASH_HEALINGASSIGNMENTS1 = "/ha"
SlashCmdList["HEALINGASSIGNMENTS"] = function(msg)
	if msg == "help" then
		print("HealingAssignments - Help")
		print("Type '/ha' to open the HealingAssignments main window")
		print("Type '/ha help' to show this message")
	else
		openHealingAssignmentsWindow()
	end
end

local init = false
local chatPrefix = "{square} "
local editting = false
local selectedChannel = nil
local selectedTactics = nil

local priest1 = 1
local priest2 = 2
local priest3 = 3
local priest4 = 4
local shaman1 = 5
local shaman2 = 6
local druid = 7
local anyHealer1 = 8
local anyHealer2 = 9
local anyHealer3 = 10
local anyHealer4 = 11
local anyHealer5 = 12
local t1 = 13
local t2 = 14
local t3 = 15
local t4 = 16
local t5 = 17
local t6 = 18
local t7 = 19
local t8 = 20
local t9 = 21
local mageTank = 22

local nextTabTarget = {}

StaticPopupDialogs["CONFIRM_DELETE_TACTICS"] = {
	text = "Are you sure you want to delete '%s' ?",
	button1 = "Yes",
	button2 = "No",
	OnAccept = function()
		deleteTactics()
	end,
	timeout = 0,
	whileDead = true,
	hideOnEscape = true,
}

 StaticPopupDialogs["ADD_TACTICS"] = {
    text = "Enter a name for the new entry",
    button1 = "Ok",
    button2 = "Cancel",
    timeout = 0,
    hasEditBox = true,
	maxLetters = 40,
    whileDead = true,
    hideOnEscape = true,
	EditBoxOnEnterPressed = function(self)
		self:GetParent().button1:Click()
	end,
	OnAccept = function(self)
		newTactics(self.editBox:GetText())
    end
};

	local frame = CreateFrame("Frame", "HealingAssignmentsWindow", UIParent, "BasicFrameTemplateWithInset")
	frame:RegisterEvent("ADDON_LOADED")
	frame:SetScript("OnEvent", function(self, event, arg1)
	if event == "ADDON_LOADED" and arg1 == "HealingAssignments" then
		if HealingAssignmentsTacticsTable == nil then
			HealingAssignmentsTacticsTable = {}
		end
		if HealingAssignmentsCharacterSelections == nil then 
			HealingAssignmentsCharacterSelections = {}
 		end
	end
end)


function openHealingAssignmentsWindow() 
	if init == false then
		init = true
		createHealingAssignmentsWindow()
	end
	HealingAssignmentsWindow:Show()
end
	
function createHealingAssignmentsWindow()
	frame:SetSize(700, 600)
	frame:SetPoint("CENTER")
	frame:SetMovable(true)
	frame:EnableMouse(true)
	frame:SetClampedToScreen(true)
	frame:SetFrameStrata("HIGH")
	frame:RegisterForDrag("LeftButton")
	frame:SetScript("OnDragStart", frame.StartMoving)
	frame:SetScript("OnDragStop", frame.StopMovingOrSizing)
	table.insert(UISpecialFrames, "HealingAssignmentsWindow")
	frame.title = frame:CreateFontString(nil, "OVERLAY")
	frame.title:SetFontObject("GameFontHighlight")
	frame.title:SetText("Healing Assignments")
	frame.title:SetPoint("LEFT", frame.TitleBg, 5, 0)
	
	frame.priest1 = createCharacterTextField("HealingAssignmentsPriest1", frame, 20, -50, "Priest 1 (P1)", priest1)
	frame.priest2 = createCharacterTextField("HealingAssignmentsPriest2", frame.priest1, 0, -50, "Priest 2 (P2)", priest2)
	frame.priest3 = createCharacterTextField("HealingAssignmentsPriest3", frame.priest2, 0, -50, "Priest 3 (P3)", priest3)
	frame.priest4 = createCharacterTextField("HealingAssignmentsPriest4", frame.priest3, 0, -50, "Priest 4 (P4)", priest4)	
	frame.shaman1 = createCharacterTextField("HealingAssignmentsShaman1", frame.priest4, 0, -50, "Shaman 1 (S1)", shaman1)
	frame.shaman2 = createCharacterTextField("HealingAssignmentsShaman2", frame.shaman1, 0, -50, "Shaman 2 (S2)", shaman2)
	
	frame.druid = createCharacterTextField("HealingAssignmentsDruid", frame, 170, -50, "Druid (D)", druid)	
	frame.anyHealer1 = createCharacterTextField("HealingAssignmentsAnyHealer1", frame.druid, 0, -50, "Any Healer 1 (AH1)", anyHealer1)
	frame.anyHealer2 = createCharacterTextField("HealingAssignmentsAnyHealer2", frame.anyHealer1, 0, -50, "Any Healer 2 (AH2)", anyHealer2)
	frame.anyHealer3 = createCharacterTextField("HealingAssignmentsAnyHealer3", frame.anyHealer2, 0, -50, "Any Healer 3 (AH3)", anyHealer3)
	frame.anyHealer4 = createCharacterTextField("HealingAssignmentsAnyHealer4", frame.anyHealer3, 0, -50, "Any Healer 4 (AH4)", anyHealer4)
	frame.anyHealer5 = createCharacterTextField("HealingAssignmentsAnyHealer5", frame.anyHealer4, 0, -50, "Any Healer 5 (AH5)", anyHealer5)

	frame.t1 = createCharacterTextField("HealingAssignmentsTank1", frame, 340, -50, "Tank 1 (T1)", t1)
	frame.t2 = createCharacterTextField("HealingAssignmentsTank2", frame.t1, 0, -50, "Tank 2 (T2)", t2)
	frame.t3 = createCharacterTextField("HealingAssignmentsTank3", frame.t2, 0, -50, "Tank 3 (T3)", t3)
	frame.t4 = createCharacterTextField("HealingAssignmentsTank4", frame.t3, 0, -50, "Tank 4 (T4)", t4)
	frame.t5 = createCharacterTextField("HealingAssignmentsTank5", frame.t4, 0, -50, "Tank 5 (T5)", t5)
	
	frame.t6 = createCharacterTextField("HealingAssignmentsTank6", frame, 510, -50, "Tank 6 (T6)", t6)
	frame.t7 = createCharacterTextField("HealingAssignmentsTank7", frame.t6, 0, -50, "Tank 7 (T7)", t7)
	frame.t8 = createCharacterTextField("HealingAssignmentsTank8", frame.t7, 0, -50, "Tank 8 (T8)", t8)
	frame.t9 = createCharacterTextField("HealingAssignmentsTank9", frame.t8, 0, -50, "Tank 9 (T9)", t9)
	frame.mageTank = createCharacterTextField("HealingAssignmentsMageTank", frame.t9, 0, -50, "Mage Tank (MGT)", mageTank)	
	
	nextTabTarget[frame.priest1.editbox] = frame.priest2.editbox
	nextTabTarget[frame.priest2.editbox] = frame.priest3.editbox
	nextTabTarget[frame.priest3.editbox] = frame.priest4.editbox
	nextTabTarget[frame.priest4.editbox] = frame.shaman1.editbox
	nextTabTarget[frame.shaman1.editbox] = frame.shaman2.editbox
	nextTabTarget[frame.shaman2.editbox] = frame.druid.editbox
	nextTabTarget[frame.druid.editbox] = frame.anyHealer1.editbox
	nextTabTarget[frame.anyHealer1.editbox] = frame.anyHealer2.editbox
	nextTabTarget[frame.anyHealer2.editbox] = frame.anyHealer3.editbox
	nextTabTarget[frame.anyHealer3.editbox] = frame.anyHealer4.editbox
	nextTabTarget[frame.anyHealer4.editbox] = frame.anyHealer5.editbox
	nextTabTarget[frame.anyHealer5.editbox] = frame.t1.editbox
	nextTabTarget[frame.t1.editbox] = frame.t2.editbox
	nextTabTarget[frame.t2.editbox] = frame.t3.editbox
	nextTabTarget[frame.t3.editbox] = frame.t4.editbox
	nextTabTarget[frame.t4.editbox] = frame.t5.editbox
	nextTabTarget[frame.t5.editbox] = frame.t6.editbox
	nextTabTarget[frame.t6.editbox] = frame.t7.editbox
	nextTabTarget[frame.t7.editbox] = frame.t8.editbox
	nextTabTarget[frame.t8.editbox] = frame.t9.editbox
	nextTabTarget[frame.t9.editbox] = frame.mageTank.editbox
	nextTabTarget[frame.mageTank.editbox] = frame.priest1.editbox
	
	local line = frame:CreateTexture()
	line:SetTexture("Interface/BUTTONS/WHITE8X8")
	line:SetColorTexture(.7 ,.7, .7, .7)
	line:SetSize(650, 1)
	line:SetPoint("TOPLEFT", frame.shaman2, "TOPLEFT", 0, -40)
	
	frame.tactics = createCombobox("HealingAssignmentsTactics", frame.priest4, -20, -170, "Tactics", "<None>")
	addTactics()

	frame.editButton = createButton(frame, "Edit", 50)
	frame.editButton:SetPoint("TOPLEFT", frame.anyHealer3, 0, -170)
    frame.editButton:SetScript("OnClick", 
		function(self, arg1)		
			if editting == true then
				editting = false
				saveTactics()
				self:SetText("Edit")
				updateButtonStatus()
				HealingAssignmentsWindow.tacticText:SetEnabled(false)				
				updateTacticsText()
			else
				editting = true
				self:SetText("Save")
				HealingAssignmentsWindow.broadcastButton:SetEnabled(false)
				HealingAssignmentsWindow.newButton:SetEnabled(false)
				HealingAssignmentsWindow.deleteButton:SetEnabled(false)
				UIDropDownMenu_DisableDropDown(HealingAssignmentsWindow.tactics)
				HealingAssignmentsWindow.priest1.editbox:SetEnabled(false)
				HealingAssignmentsWindow.priest2.editbox:SetEnabled(false)
				HealingAssignmentsWindow.priest3.editbox:SetEnabled(false)
				HealingAssignmentsWindow.priest4.editbox:SetEnabled(false)
				HealingAssignmentsWindow.shaman1.editbox:SetEnabled(false)
				HealingAssignmentsWindow.shaman2.editbox:SetEnabled(false)
				HealingAssignmentsWindow.druid.editbox:SetEnabled(false)
				HealingAssignmentsWindow.anyHealer1.editbox:SetEnabled(false)
				HealingAssignmentsWindow.anyHealer2.editbox:SetEnabled(false)
				HealingAssignmentsWindow.anyHealer3.editbox:SetEnabled(false)
				HealingAssignmentsWindow.anyHealer4.editbox:SetEnabled(false)
				HealingAssignmentsWindow.anyHealer5.editbox:SetEnabled(false)
				HealingAssignmentsWindow.t1.editbox:SetEnabled(false)
				HealingAssignmentsWindow.t2.editbox:SetEnabled(false)
				HealingAssignmentsWindow.t3.editbox:SetEnabled(false)
				HealingAssignmentsWindow.t4.editbox:SetEnabled(false)
				HealingAssignmentsWindow.t5.editbox:SetEnabled(false)
				HealingAssignmentsWindow.t6.editbox:SetEnabled(false)
				HealingAssignmentsWindow.t7.editbox:SetEnabled(false)
				HealingAssignmentsWindow.t8.editbox:SetEnabled(false)
				HealingAssignmentsWindow.t9.editbox:SetEnabled(false)
				HealingAssignmentsWindow.mageTank.editbox:SetEnabled(false)
				HealingAssignmentsWindow.tacticText:SetEnabled(true)

				local text = ""
				for _, line in pairs(HealingAssignmentsTacticsTable[selectedTactics]) do
					text = text .. line .. "\n"
				end
				HealingAssignmentsWindow.tacticText:SetText(text)
			end
		end
	)	
	
	frame.newButton = createButton(frame, "+", 30)
	frame.newButton:SetEnabled(true)
	frame.newButton:SetPoint("TOPLEFT", frame.editButton, 60, 0)
    frame.newButton:SetScript("OnClick", 
		function(self, arg1)		
			StaticPopup_Show ("ADD_TACTICS")
		end
	)	

	frame.deleteButton = createButton(frame, "-", 30)
	frame.deleteButton:SetPoint("TOPLEFT", frame.newButton, 40, 0)
    frame.deleteButton:SetScript("OnClick", 
		function(self, arg1)
			if selectedTactics ~= nil then
				StaticPopup_Show ("CONFIRM_DELETE_TACTICS", selectedTactics)
			end
		end
	)	
	
	frame.channel = createCombobox("HealingAssignmentsTactics", frame.t4, -20, -170, "Channel", "<None>")
	addChannels(frame.channel)
	
	frame.broadcastButton = createButton(frame, "Broadcast", 120)
	frame.broadcastButton:SetPoint("TOPLEFT", frame.t9, 0, -170)
    frame.broadcastButton:SetScript("OnClick", 
		function(self, arg1)
			broadcast()
		end
	)	

	frame.scrollFrame = CreateFrame("ScrollFrame", "HealingAssignmentsScrollFrame", HealingAssignmentsWindow, "UIPanelScrollFrameTemplate" and "BackdropTemplate")
	frame.scrollFrame:SetPoint("TOPLEFT", frame.tactics, "TOPLEFT", 20, -50)
	frame.scrollFrame:SetPoint("BOTTOMRIGHT", HealingAssignmentsWindow.InsetBg, "BOTTOMRIGHT", -30, 20)
	frame.scrollFrame:SetBackdrop({
		bgFile 		= "Interface\\TutorialFrame\\TutorialFrameBackground",
		edgeFile = "Interface\\Buttons\\WHITE8X8", 
        edgeSize = 1,
		insets = { 5, 5, 5, 5 }
	})
	
	frame.tacticText = CreateFrame("EditBox", "HealingAssignmentsEditBox", HealingAssignmentsScrollFrame)	
	frame.tacticText:SetWidth(640)	
	frame.tacticText:SetTextInsets(5, 5, 5, 5)
	frame.tacticText:SetFontObject(ChatFontNormal)
	frame.tacticText:SetAutoFocus(false)
	frame.tacticText:SetMultiLine(true)
	frame.tacticText:SetMaxLetters(99999)
	frame.tacticText:SetEnabled(false)	
	frame.scrollFrame:SetScrollChild(frame.tacticText)	
end

function saveTactics()
	HealingAssignmentsTacticsTable[selectedTactics] = splitString(HealingAssignmentsWindow.tacticText:GetText(), "\n")
end

function createButton(parent, label, width)
	local button = CreateFrame("Button", nil, parent)
	button:SetPoint("CENTER", parent, "CENTER", 0, 0)
	button:SetWidth(width)
	button:SetHeight(25)	
	button:SetText(label)
	button:SetNormalFontObject("GameFontNormal")	
	local ntex = button:CreateTexture()
	ntex:SetTexture("Interface/Buttons/UI-Panel-Button-Up")
	ntex:SetTexCoord(0, 0.625, 0, 0.6875)
	ntex:SetAllPoints()	
	button:SetNormalTexture(ntex)	
	local htex = button:CreateTexture()
	htex:SetTexture("Interface/Buttons/UI-Panel-Button-Highlight")
	htex:SetTexCoord(0, 0.625, 0, 0.6875)
	htex:SetAllPoints()
	button:SetHighlightTexture(htex)	
	local ptex = button:CreateTexture()
	ptex:SetTexture("Interface/Buttons/UI-Panel-Button-Down")
	ptex:SetTexCoord(0, 0.625, 0, 0.6875)
	ptex:SetAllPoints()
	button:SetPushedTexture(ptex)
	local dtex = button:CreateTexture()
	dtex:SetTexture("Interface\\Buttons\\UI-Panel-Button-Disabled")
	dtex:SetTexCoord(0, 0.625, 0, 0.6875)
	dtex:SetAllPoints()
	button:SetDisabledTexture(dtex)
	button:SetEnabled(false)
	return button
end


function broadcast()
	if selectedChannel ~= nil and selectedTactics ~= nil then
		local textLines = getTextLines()
		local chatType = "CHANNEL"
		if selectedChannel == 0 then
			chatType = "RAID"
		end
		SendChatMessage(chatPrefix .. selectedTactics, chatType, "COMMON", selectedChannel)
		for i = 1, #textLines do
			SendChatMessage(chatPrefix .. textLines[i], chatType, "COMMON", selectedChannel)
		end
	end
end

function MyGetChannelName(index)
	if index == 0 then
		return 0, "raid"
	else
		return GetChannelName(index)
	end
end

function addChannels(combobox)
	local unusedChannels = {"General", "Trade", "LocalDefense", "LookingForGroup", "GuildRecruitment"}
	combobox.initialize = function(self, level)
		for i = 0, 10 do
			local id, name = MyGetChannelName(i)
			if id ~= nil and name ~= nil then
				local use = true		
				for j = 1, #unusedChannels do
					if string.find(name, unusedChannels[j]) ~= nil then
						use = false
						break
					end
				end
				if use then
					local info = UIDropDownMenu_CreateInfo()
					info.text = name
					info.value = name
					info.arg1 = id
					info.func = function(b)
						UIDropDownMenu_SetSelectedValue(combobox, b.value, b.value, b.arg1)
						UIDropDownMenu_SetText(combobox, b.value)
						b.checked = true
						selectedChannel = b.arg1
						updateButtonStatus()
					end
					UIDropDownMenu_AddButton(info)
				end
			end		
		end
	end
end

function addTactics() 
	HealingAssignmentsWindow.tactics.initialize = function(self, level)
		local orderedTacticNames = {}
		for tacticName in pairs(HealingAssignmentsTacticsTable) do
			table.insert(orderedTacticNames, tacticName)
		end
		table.sort(orderedTacticNames)
		for i = 1,#orderedTacticNames do
			local tacticName = orderedTacticNames[i]
			local info = UIDropDownMenu_CreateInfo()
			info.text = tacticName
			info.value = tacticName
			info.checked = selectedTactics == tacticName
			info.func = function(b)
				UIDropDownMenu_SetSelectedValue(HealingAssignmentsWindow.tactics, b.value, b.value, b)
				UIDropDownMenu_SetText(HealingAssignmentsWindow.tactics, b.value)
				b.checked = true
				selectedTactics = b.value
				updateTacticsText()
				updateButtonStatus()
			end
			UIDropDownMenu_AddButton(info)
		end
	end
end

function updateButtonStatus()
	HealingAssignmentsWindow.priest1.editbox:SetEnabled(true)
	HealingAssignmentsWindow.priest2.editbox:SetEnabled(true)
	HealingAssignmentsWindow.priest3.editbox:SetEnabled(true)
	HealingAssignmentsWindow.priest4.editbox:SetEnabled(true)
	HealingAssignmentsWindow.shaman1.editbox:SetEnabled(true)
	HealingAssignmentsWindow.shaman2.editbox:SetEnabled(true)
	HealingAssignmentsWindow.druid.editbox:SetEnabled(true)
	HealingAssignmentsWindow.anyHealer1.editbox:SetEnabled(true)
	HealingAssignmentsWindow.anyHealer2.editbox:SetEnabled(true)
	HealingAssignmentsWindow.anyHealer3.editbox:SetEnabled(true)
	HealingAssignmentsWindow.anyHealer4.editbox:SetEnabled(true)
	HealingAssignmentsWindow.anyHealer5.editbox:SetEnabled(true)
	HealingAssignmentsWindow.t1.editbox:SetEnabled(true)
	HealingAssignmentsWindow.t2.editbox:SetEnabled(true)
	HealingAssignmentsWindow.t3.editbox:SetEnabled(true)
	HealingAssignmentsWindow.t4.editbox:SetEnabled(true)
	HealingAssignmentsWindow.t5.editbox:SetEnabled(true)
	HealingAssignmentsWindow.t6.editbox:SetEnabled(true)
	HealingAssignmentsWindow.t7.editbox:SetEnabled(true)
	HealingAssignmentsWindow.t8.editbox:SetEnabled(true)
	HealingAssignmentsWindow.t9.editbox:SetEnabled(true)
	HealingAssignmentsWindow.mageTank.editbox:SetEnabled(true)

	HealingAssignmentsWindow.newButton:SetEnabled(true)
	UIDropDownMenu_EnableDropDown(HealingAssignmentsWindow.tactics)
	if selectedTactics ~= nil and selectedTactics ~= "<None>" then
		HealingAssignmentsWindow.editButton:SetEnabled(true)
		HealingAssignmentsWindow.deleteButton:SetEnabled(true)
		if selectedChannel ~= nil then
			HealingAssignmentsWindow.broadcastButton:SetEnabled(true)
		end
	else
		HealingAssignmentsWindow.editButton:SetEnabled(false)
		HealingAssignmentsWindow.deleteButton:SetEnabled(false)
		HealingAssignmentsWindow.broadcastButton:SetEnabled(false)
	end
end

function newTactics(tacticName)
	if HealingAssignmentsTacticsTable[tacticName] == nil then
		HealingAssignmentsTacticsTable[tacticName] = {""}
	end
	selectedTactics = tacticName
	UIDropDownMenu_SetText(HealingAssignmentsWindow.tactics, selectedTactics)
	addTactics()
	updateTacticsText()
	updateButtonStatus()
end

function deleteTactics()
	HealingAssignmentsTacticsTable[selectedTactics] = nil
	selectedTactics = nil
	local orderedTacticNames = {}
	for tacticName in pairs(HealingAssignmentsTacticsTable) do
		table.insert(orderedTacticNames, tacticName)
	end	
	table.sort(orderedTacticNames)
	for i = 1,#orderedTacticNames do
		selectedTactics = orderedTacticNames[i]
		break
	end
	if selectedTactics == nil then
		UIDropDownMenu_SetText(HealingAssignmentsWindow.tactics, "<None>")
	else
		UIDropDownMenu_SetText(HealingAssignmentsWindow.tactics, selectedTactics)
	end
	addTactics()
	updateTacticsText()
	updateButtonStatus()
end

function updateTacticsText()
	local textLines = getTextLines()
	local text = ""
	for i = 1, #textLines do
		text = text .. textLines[i] .. "\n"
	end
	HealingAssignmentsWindow.tacticText:SetText(text)
end

function getTextLines()
	local textLines = {}
	if selectedTactics ~= nil then
		for _, line in pairs(HealingAssignmentsTacticsTable[selectedTactics]) do
			table.insert(textLines, replacePlaceholders(line))
		end
	end
	return textLines
end

function replacePlaceholders(line)
	line = substitute(line, "P1", HealingAssignmentsCharacterSelections[priest1])
	line = substitute(line, "P2", HealingAssignmentsCharacterSelections[priest2])
	line = substitute(line, "P3", HealingAssignmentsCharacterSelections[priest3])
	line = substitute(line, "P4", HealingAssignmentsCharacterSelections[priest4])
	line = substitute(line, "S1", HealingAssignmentsCharacterSelections[shaman1]) 
	line = substitute(line, "S2", HealingAssignmentsCharacterSelections[shaman2])
	line = substitute(line, "D", HealingAssignmentsCharacterSelections[druid])
	line = substitute(line, "AH1", HealingAssignmentsCharacterSelections[anyHealer1])
	line = substitute(line, "AH2", HealingAssignmentsCharacterSelections[anyHealer2])
	line = substitute(line, "AH3", HealingAssignmentsCharacterSelections[anyHealer3])
	line = substitute(line, "AH4", HealingAssignmentsCharacterSelections[anyHealer4])
	line = substitute(line, "AH5", HealingAssignmentsCharacterSelections[anyHealer5])
	line = substitute(line, "T1", HealingAssignmentsCharacterSelections[t1])
	line = substitute(line, "T2", HealingAssignmentsCharacterSelections[t2])
	line = substitute(line, "T3", HealingAssignmentsCharacterSelections[t3])
	line = substitute(line, "T4", HealingAssignmentsCharacterSelections[t4])
	line = substitute(line, "T5", HealingAssignmentsCharacterSelections[t5])
	line = substitute(line, "T6", HealingAssignmentsCharacterSelections[t6])
	line = substitute(line, "T7", HealingAssignmentsCharacterSelections[t7])
	line = substitute(line, "T8", HealingAssignmentsCharacterSelections[t8])
	line = substitute(line, "T9", HealingAssignmentsCharacterSelections[t9])
	line = substitute(line, "MGT", HealingAssignmentsCharacterSelections[mageTank])
	return line
end

function substitute(line, placeholder, replacement)
	if replacement ~= "" then
		line = string.gsub(line, "%(" .. placeholder .. "%)", replacement)
	end
	return line
end

function createCharacterTextField(name, relativeTo, divX, divY, label, selectionIndex)
	local editFrame = CreateFrame("Frame", "HealingAssignmentsScrollFrame" .. name, HealingAssignmentsWindow, "BackdropTemplate")
	editFrame:SetPoint("TOPLEFT",relativeTo, "TOPLEFT", divX, divY)	
	editFrame:SetWidth(124)
	editFrame:SetHeight(26)
	editFrame:SetBackdrop({
		bgFile = "Interface\\TutorialFrame\\TutorialFrameBackground",
		edgeFile = "Interface\\Buttons\\WHITE8X8", 
        edgeSize = 1,
		insets = { 5, 5, 5, 5 }
	})
	
	editFrame.editbox = CreateFrame("EditBox", name, HealingAssignmentsWindow)
	editFrame.editbox:SetMultiLine(false)
	editFrame.editbox:SetPoint("TOPLEFT",editFrame, "TOPLEFT", 3, -2)	
	editFrame.editbox:SetFontObject(ChatFontNormal)
	editFrame.editbox:SetWidth(120)
	editFrame.editbox:SetHeight(22)	
	if HealingAssignmentsCharacterSelections[selectionIndex] ~= nil then
		editFrame.editbox:SetText(HealingAssignmentsCharacterSelections[selectionIndex])
	end
	editFrame.editbox:SetScript("OnEnterPressed", function(self)
		self:SetAutoFocus(false)
		self:ClearFocus()
		nextTabTarget[self]:SetAutoFocus(true)		
	end)
	editFrame.editbox:SetScript("OnEscapePressed", function(self)
		HealingAssignmentsWindow:Hide()
	end)
	editFrame.editbox:SetScript("OnCursorChanged", 
		function(self, arg1)
			HealingAssignmentsCharacterSelections[selectionIndex] = self:GetText()
			updateTacticsText()
		end
	)	
	editFrame.label = editFrame:CreateFontString(nil)
	editFrame.label:SetFont("Fonts\\ARIALN.ttf", 13, "OUTLINE")
    editFrame.label:SetPoint("TOPLEFT", relativeTo, divX, divY + 15)
	editFrame.label:SetText(label)
	return editFrame	
end

function createCombobox(name, relativeTo, divX, divY, label, selectedValue) 
	local frame = CreateFrame("Frame", name, HealingAssignmentsWindow, "UIDropDownMenuTemplate")
	frame:SetPoint("TOPLEFT", relativeTo, divX, divY)
	UIDropDownMenu_SetWidth(frame, 120)
	UIDropDownMenu_SetText(frame, selectedValue)
	frame.label = frame:CreateFontString(nil)
	frame.label:SetFont("Fonts\\ARIALN.ttf", 13, "OUTLINE")	
    frame.label:SetPoint("TOPLEFT", relativeTo, divX + 20, divY + 15)
	frame.label:SetText(label)
	return frame
	
end


function splitString (inputstring, separator)
	local result = {}
    for token in string.gmatch(inputstring, "([^"..separator.."]+)") do
		table.insert(result, token);
	end
	return result
end